/* Tea Steaper */

#include <Servo.h> 
 
Servo myservo;  // add servo object
 
int pos = 45;    // variable to store the servo position 
int potPin = A2;    // select the input pin for the potentiometer 
int long val = 0;       // variable to store delay time for strength of tea
const int buttonPin = 5;     // start button pin
int buttonState = 0; // set button state to 0

void setup() 
{ 
  myservo.attach(3);  // adds servo to pin 3
    pinMode(A0, OUTPUT); // set A0 for first red LED to output
      pinMode(13, OUTPUT); // set pin 13 for second red LED to output
        pinMode(12, OUTPUT); // set pin 12 for thrid red LED to output
          pinMode(8, OUTPUT); // set pin 13 for first yellow LED to output
            pinMode(4, OUTPUT); // set pin 13 for second yellow LED to output
              pinMode(2, OUTPUT); // set pin 13 for green LED to output
                pinMode(A3, OUTPUT); // set A3 for audio trigger to output
                 pinMode(buttonPin, INPUT); // set button pin (pin 5) to input  
} 
 
void loop() 
{ 

  myservo.write(pos); // initialize servo to starting position

  buttonState = digitalRead(buttonPin); // read start button state

    if (buttonState == HIGH) // this reads the state of the buttonPin. If button is pushed then the program starts
    {   

// to save programming space I used functions for each of the servo actions. 
// these first actions are used to mimic what a person would do when first dipping the tea bag

for(int i=0; i < 6; i++)
downUP(i);

delay(500);

for(int i=0; i < 6; i++)
downUP(i);

delay(500);

// the slowDown action slowly drops the tea bag into the water

slowDown();

  // I used the map and analogRead to read values from the potentiomter to set the delay time
  // the delay time will adjust the strength of the tea. The steep time for each dip can be
  // from 10 sec to 30 sec on the first two steeps and 10 sec to 60 sec on the last steeps.
  // I use the read function individually for each steep so that
  // the strength of the tea can be fine tuned at any time of the steep
    val = map(analogRead(potPin),0,1023, 60000,10000) ;    // read the value from the sensor
    delay(val);

slowUp();
  
  // after each steep cycle I turn one of the LEDs on 
  digitalWrite(A0, HIGH); 

  delay(1000);

slowDown();
  val = map(analogRead(potPin),0,1023, 30000,10000) ;   // read the value from the sensor 
  delay(val);
  
slowUp();
  digitalWrite(13, HIGH); 

  delay(1000);

slowDown();
   val = map(analogRead(potPin),0,1023, 30000,10000) ;   // read the value from the sensor   
   delay(val);

slowUp();
  digitalWrite(12, HIGH); 
    
  delay(1000);
  
slowDown();
  val = map(analogRead(potPin),0,1023, 60000,10000) ;   // read the value from the sensor 
  delay(val);

slowUp();
  digitalWrite(8, HIGH); 

  delay(1000);
  
slowDown();
  val = map(analogRead(potPin),0,1023, 60000,10000) ;   // read the value from the sensor
  delay(val);

slowUp();
  digitalWrite(4, HIGH); 
  
  delay(1000);
  
slowDown();
  val = map(analogRead(potPin),0 , 1023 , 60000, 10000);    // read the value from the sensor
  delay(val);

slowUp();
  digitalWrite(2, HIGH); 
  
  // after the last steep I activate the recorded message    
  digitalWrite(A3, HIGH);
  delay(5);
  // turn the signal off
  digitalWrite(A3, LOW);
  delay(5000);
  
    // turn each light off individually
    digitalWrite(2, LOW);
    delay(500);
        digitalWrite(4, LOW);
        delay(500);
            digitalWrite(8, LOW);
            delay(500);
                digitalWrite(12, LOW);
                delay(500);
                    digitalWrite(13, LOW);
                    delay(500);
                        digitalWrite(A0, LOW);
                        delay(500);
                            // turn the green light back on to indicate the steep is finished
                            digitalWrite(2, HIGH);
                            // keep the green light on for 20 seconds
                            delay(20000);
        // turn green led off
        digitalWrite(2, LOW);
        //steep is now complete and arduino finishes the if loop and waits for buttonPin to == HIGH to start again
  }
}

// action functions

void downUp() 
{
 
  for(pos = 45; pos >=5; pos-=1)     // goes from 45 degrees to 5 degrees 
  {                                
    myservo.write(pos);              // tell servo to go to position in variable 'pos' 
    delay(5);                       // waits 5ms for the servo to reach the position 
  } 
    for(pos = 5; pos <= 45; pos += 1) // goes from 5 degrees to 45 degrees 
  {                                  // in steps of 1 degree 
    myservo.write(pos);              // tell servo to go to position in variable 'pos' 
    delay(5);                       // waits 5ms for the servo to reach the position 
  } 
}

void slowDown()
{
    for(pos = 45; pos >=5; pos-=1)     // goes from 45 degrees to 5 degrees 
  {                                
    myservo.write(pos);              // tell servo to go to position in variable 'pos' 
    delay(30);                       // waits 30ms for the servo to reach the position 
  }
} 

void slowUp() 
{
  for(pos = 5; pos <= 45; pos += 1) // goes from 5 degrees to 45 degrees 
  {                                  // in steps of 1 degree 
    myservo.write(pos);              // tell servo to go to position in variable 'pos' 
    delay(15);                       // waits 30ms for the servo to reach the position 
} 
  }  
